unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, hyieutils, iexBitmaps, hyiedefs,
  iesettings, iexLayers, iexRulers, ieview, imageenview, Vcl.ExtCtrls, iemview,
  iexLayerMView, Vcl.Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    ImageEnViewMain: TImageEnView;
    iemLayers: TImageEnLayerMView;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ImageEnViewMain.ClearAll;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  ImageEnViewMain.IO.LoadFromFileAuto(ImageEnViewMain.IO.ExecuteOpenDialog());
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
var
  Idx: Integer;
  X, Y: Integer;
  Clr: TRGB;
  R,G,B: Integer;
begin
  if ImageEnViewMain.IsEmpty then
    Exit;

  ImageEnViewMain.LockUpdate;

  Idx := ImageEnViewMain.LayersAdd();
  ImageEnViewMain.CurrentLayer.Assign(ImageEnViewMain.Layers[Idx - 1]);
  ImageEnViewMain.CurrentLayer.Name := 'My New Layer';
  ImageEnViewMain.CurrentLayer.Locked := True;

  //Perform custom selection on this new layer
  ImageEnViewMain.Deselect;

  //Select all pixles with rgb Lessthen midtone value
  for Y := 0 to ImageEnViewMain.IEBitmap.Height - 1 do
  begin
    for X := 0 to ImageEnViewMain.IEBitmap.Width - 1 do
    begin
      Clr := ImageEnViewMain.IEBitmap.Pixels[X,Y];
      R := Clr.r;
      G := Clr.g;
      B := Clr.b;

      if ((R < 200) and (G < 200) and (B < 200)) then
      begin
        ImageEnViewMain.SelectionMask.SetPixel(X,Y,1);
      end;
    end;
  end;
  ImageEnViewMain.SelectionMaskDepth := 8;
  ImageEnViewMain.SelectCustom;

  ShowMessage('Verify that there is NO Selection when you click on the button for first time' + #13 + 'When you click the button next time you will SEE Custom Selection');

  ImageEnViewMain.LayersCreateFromSelection();
  ImageEnViewMain.CurrentLayer.Name := 'From Selection';

  Application.ProcessMessages;

  //ImageEnViewMain.Deselect;

  ImageEnViewMain.UnLockUpdate;
  ImageEnViewMain.Update;
end;

end.
